mrrl

Minimal Reliable Reproducible Linux
git clone https://ccx.te2000.cz/git/mrrl
Log | Files | Refs | Submodules | README

diffutils (5759B)


      1 #!/usr/bin/env pthbs-build
      2 #+busybox.7f0e4d86f69de7624b0468018b9933c3e3c1757c8ff73938746c292196f916dd
      3 #+busybox-bzip2.52d2053dff44277d3c6f700eec6807d2c64c226e0f1bf589372ff5ff625be40e
      4 #+busybox-gzip.085fc42ce36be284c89a9dec6889cca59dedd07b9ba93a21d3198c4adcac5840
      5 #+busybox-lzop.bccd8f86de85a74d466d34f802ab1ea355f0a9d9886bdfa4d7bb4a785d695be6
      6 #+busybox-unzip.237a4ec36283b7fbdb85df583c7c77c0aaf70d335b1cbae09a40a9bb4b6c82bb
      7 #+busybox-xz.db25ed2ffbfc91e7b5cff54faf2e80de59ab5b15167c2c5bb338fa1ee62de122
      8 #+busybox-cpio.307e9495bcd9b79fd9559882115d55d22c5b687e08886e696f1e53d8db7eebcd
      9 #+busybox-dpkg.3aec8347093bb5b774a0c25795cdf9e624268a3b04cc48e867d74e4e06461db7
     10 #+busybox-rpm.8435251ea7058aea0cbcd41478b144b1a15c5aa121509af887847c0ef45bf5aa
     11 #+busybox-tar.c77139157bce13db8820740b756572c22e29cfbd8bb8c2a3b22b465b70e2eae9
     12 #+busybox-ed.4ac872215d7b9c8096c4cfd508434fbd2e825aebd9a9ea8589a0033b8e50aac2
     13 #+busybox-sed.14269a860b3706f7122b827818365fecaa0e62ce5bc3273e89948685c0953f2d
     14 #+busybox-vi.7e41b306c9c47aaaa281aa8347b9fa6dca260788fd73f53a7ba9260b315627ee
     15 #+busybox-xxd.9df3407fd75b89cb640d65870298eaba77327d6e387d25d8ce1ebab01cb47857
     16 #+busybox-process-extra.65afeaded3cb8fdeea327262f28f08e50f18d51a2b456ea97b293d200c7f558e
     17 #+busybox-procps.e5dc609521d29d8aec8253147269314439131c088a6beeacc172fc07594c4a37
     18 #+busybox-psmisc.7d760b69f45bb1b8d458f2f408b9cb3a42e919e8022f0508c440a5fd20ebb66f
     19 #+busybox-ash.fd5d266905d40248735e0e2e1ae22165b6f0d42c0bacb652660f69f39c1ee71e
     20 #+busybox-bc.6f2fe17efab2237c3036eba1c37d432d696d1b5dba130e21365016ceae0a3184
     21 #+busybox-coreutils.7e581faa6901f832a2a022d72b2858c3091f47afc80a4a463adb2f2a68f1843d
     22 #+busybox-coreutils-extra.5ab183b839676b0780a9a83d75cc345a06221fa34627c44aa3732c4a5a47f9b9
     23 #+busybox-daemontools.bcea69c867a61fe1d49d2f6a27e406959c484ed20d54fd7c0341828d3cdbd428
     24 #+busybox-grep.ac20e6a4295eb7fb0a09d700e10e5fe55e2009d2858e0a1525e461d4914e820b
     25 #+busybox-misc.7f0588b97809fac8061c489b686424de1a7dd17d8eb3431aae56513c7288f1e7
     26 #+busybox-sh.288f0583edc783a176bbbc59a3e854b186258ba2605291377a545cc3191c3d52
     27 #+busybox-util-linux-unpriv.5a286246aa7204f7fa8c9a247f1c93c751979690a65200030f29e255645c1eae
     28 #+busybox-findutils.207f73a9f41a8f9e279072e920cbf0c38ba6516734fa3cf2c1faf55565613487
     29 #+nawk.84c186be0a6d09a951a8c6a5377d16b0ba0a9e476e6b554c0c832d6407ebb5b2
     30 #+busybox-diffutils.895f7a6bf6d00136038d8bafa91a6fb1e7027ce5a32e1e3b64a9119fe69ef19a
     31 #+musl-cross-make.19d51dec5328ccacd41d47d7f24e33bac084aebefb839cb3fecb6573577b831a
     32 #+gnu-make.17b0037e8a3f24180cb7bb9ddb488039d540ba905aecca0315de313adfbae81c
     33 #+m4.615d99c28c6a4c9a2fab9b75c3ae68b6adf51a7afc4b03482077a284888aedb4
     34 #@untar:-J:sha256:90e5e93cc724e4ebe12ede80df1634063c7a855692685919bfe60b556c9bd09e:.
     35 
     36 
     37 # - build script start -
     38 
     39 autotools_config() {
     40 	prefix=/versions/$pthbs_package
     41 	./configure -C \
     42 		--prefix="$prefix" \
     43 		--build="$(${CC:-gcc} -dumpmachine)" \
     44 		--bindir="$prefix/command" \
     45 		--sbindir="$prefix/command" \
     46 		--infodir="$prefix/info" \
     47 		--localedir="$prefix/locale" \
     48 		--mandir="$prefix/man" \
     49 		--libdir="$prefix/library" \
     50 		--docdir="$prefix/doc/diffutils" \
     51 		--datadir="$prefix/data" \
     52 		--datarootdir="$prefix/data" \
     53 		--localstatedir='/var/pthbs' \
     54 		"$@"
     55 
     56 }
     57 
     58 autotools_config_static() {
     59 	autotools_config "$@" --enable-static --disable-shared
     60 }
     61 
     62 build_env_static() {
     63 	export CFLAGS="-ffile-prefix-map=${pthbs_workdir}=builddir $CFLAGS"
     64 	export CXXFLAGS="-ffile-prefix-map=${pthbs_workdir}=builddir $CXXFLAGS"
     65 	export LDFLAGS="-static -L$pthbs_build_environment/library $LDFLAGS"
     66 }
     67 
     68 check_static() {
     69 	local exe || true
     70 	exe=$pthbs_destdir'/versions'/$pthbs_package/$1
     71 	if ! test -f $exe; then
     72 		printf '%s\n' "Error: file '$1' doesn't exist!"
     73 		exit 1
     74 	fi
     75 	local interp_info || true
     76 	interp_info=$(readelf --string-dump=.interp "$exe") || exit $?
     77 	if test x '!=' "x$interp_info"; then
     78 		printf '%s\n' "Error: '$1' is a dynamic binary!"
     79 		exit 1
     80 	fi
     81 }
     82 
     83 prefix=/versions/$pthbs_package
     84 dest=${pthbs_destdir%/}${prefix}
     85 cd 'diffutils-3.10'
     86 
     87 
     88 build_env_static
     89 autotools_config_static --disable-nls
     90  
     91 
     92 make -j${JOBS:-1} -l$((1+${JOBS:-1}))
     93 
     94 make DESTDIR="$pthbs_destdir" install
     95 
     96 
     97 
     98 check_static command/diff
     99 check_static command/cmp
    100 
    101 
    102 
    103 cd "$pthbs_destdir/versions/$pthbs_package"
    104 find -type d -o -print | awk -F/ '
    105 BEGIN {
    106 	x["./command/diff"]=1
    107 	x["./man/man1/diff.1"]=1
    108 }
    109 
    110 function r1(s) {
    111 	sub("^[.]/[^/]*", ".", s)
    112 	return s
    113 }
    114 function s1(repl, s) {
    115 	sub("^[.]/[^/]*", "./"repl, s)
    116 	return s
    117 }
    118 function link(src) {
    119 	x[$0]=0
    120 	printf "%s\t%s\n", $0, src
    121 	printf "genlinks >>%s\t%s<<\n", $0, src >>"/dev/stderr"
    122 }
    123 $1!="."{exit 1}
    124 $2 == "env" { link($0); next }
    125 $2 == ".env-template" { link($0); next }
    126 
    127 $2 == "command" { link($0); next }
    128 $2 == "command" { link($0); next }
    129 $2 == "bin" { link(s1("command", $0)); next }
    130 $2 == "sbin" { link(s1("command", $0)); next }
    131 
    132 $2 == "library.so" { link($0); next }
    133 $2 == "library" { link($0); next }
    134 $2 == "lib" && $NF ~ /\.l?a$/ { link(s1("library", $0)); next }
    135 $2 == "lib" && $NF ~ /\.so(\..*)?$/ { link(s1("library.so", $0)); next }
    136 
    137 $2 == "share" && $3 == "info" { link(s1("info", r1($0))); next }
    138 $2 == "share" && $3 == "man" { link(s1("man", r1($0))); next }
    139 $2 == "share" && $3 == "doc" { link(s1("doc", r1($0))); next }
    140 
    141 $2 == "config" { link($0); next }
    142 $2 == "man" { link($0); next }
    143 $2 == "info" { link($0); next }
    144 $2 == "doc" { link($0); next }
    145 $2 == "data" { link($0); next }
    146 $2 == "include" { link($0); next }
    147 
    148 
    149 { printf "genlinks ##%s## skipped\n", $0 >>"/dev/stderr" }
    150 
    151 END {
    152 	for(fname in x) { printf "DEBUG: x[\"%s\"]=\"%s\"\n", fname, x[fname] >"/dev/stderr" }
    153 	retcode = 0
    154 	for(fname in x) {
    155 		if(x[fname]) {
    156 			printf "ERROR: missing expected file \"%s\"\n", fname >"/dev/stderr"
    157 			retcode = 3
    158 		}
    159 	}
    160 	exit retcode
    161 }' >.install-links.new
    162 mv .install-links.new .install-links
    163